﻿Module Module1

    Private northwindContext As NorthwindEntities

    Sub Main()
        Try
            northwindContext = New NorthwindEntities

        Catch ex As SqlClient.SqlException
        Catch ex As Exception

        End Try

        'AddProduct(northwindContext.Categories.Single(Function(cat) cat.CategoryName = "Seafood"))
        'LINQtoEntitiesDemo("Seafood")
        For Each prod In northwindContext.TenMostExpensiveProducts
            Console.WriteLine(prod)
        Next
        Console.ReadLine()

    End Sub


    Sub UpdateProduct()

        Try
            Dim check = northwindContext.Products.
                        Single(Function(p) p.
                        ProductName = "Italian spaghetti")

            check.Discontinued = True
            check.UnitsInStock = 30
            northwindContext.SaveChanges()

            'Product does not exist
        Catch ex As InvalidOperationException

        Catch ex As UpdateException

        End Try
    End Sub

    Sub DeleteProduct()

        Try
            Dim check = northwindContext.Products.
                        Single(Function(p) p.
                        ProductName = "Italian spaghetti")
            northwindContext.Products.DeleteObject(check)
            northwindContext.SaveChanges()

            'Does not exist
        Catch ex As InvalidOperationException

        Catch ex As UpdateException

        End Try

    End Sub

    Sub AddProduct(ByVal categoryReference As Category)
        Try

            Dim check = northwindContext.Products.
                        Single(Function(p) p.
                        ProductName = "Italian spaghetti")

        Catch ex As InvalidOperationException

            Try
                Dim prod As New Product
                With prod
                    .ProductName = "Italian spaghetti"
                    .QuantityPerUnit = "10 packs"
                    .Discontinued = True
                    .SupplierID = 4
                    .UnitPrice = 0.5D
                    .UnitsInStock = 100
                    .UnitsOnOrder = 50

                    .Category = categoryReference
                End With

                northwindContext.Products.AddObject(prod)
                'Deprecated:
                'northwindContext.AddToProducts(prod)
                northwindContext.SaveChanges()

            Catch e As OptimisticConcurrencyException
                northwindContext.Refresh(Objects.RefreshMode.ClientWins,
                                         northwindContext.Products)
                northwindContext.SaveChanges()
            Catch e As UpdateException
                Console.WriteLine(e.Message)
            Catch e As ArgumentException
                Console.WriteLine(e.Message)

            Catch e As Exception

            End Try

        Catch ex As Exception
            'Handle general exceptions here
        End Try
    End Sub

    Sub EntitySQLDemo()
        Try
            Dim grainProducts = northwindContext.
                                CreateQuery(Of Product)("SELECT * FROM PRODUCTS WHERE " & _
                                "CATEGORYID='5' ORDER BY PRODUCTNAME").
                                Execute(Objects.MergeOption.AppendOnly)

            Dim grainProducts2 = northwindContext.
                                 ExecuteStoreQuery(Of Product)("SELECT * FROM PRODUCTS WHERE " & _
                                 "CATEGORYID='5' ORDER BY PRODUCTNAME")

            Dim numberOfRows As Integer = _
                northwindContext.ExecuteStoreCommand("DELETE FROM PRODUCTS")

        Catch ex As EntitySqlException
            Console.WriteLine("An error occurred in column: {0}",
                              ex.Column.ToString)
        Catch ex As Exception
            Console.WriteLine(ex.ToString)
        End Try
    End Sub

    Sub LINQtoEntitiesDemo(ByVal CategoryName As String)

        Dim query = From prod In northwindContext.Products.
                    Include("Category")
                    Where prod.Category.CategoryName = CategoryName _
                    And prod.Discontinued = False
                    Order By prod.UnitPrice
                    Select prod

        Console.WriteLine("Category: {0}",
                          CategoryName)

        For Each prod In query
            Console.WriteLine("Product name: {0}, Unit price: {1:c}",
                              prod.ProductName, prod.UnitPrice)
        Next
    End Sub

End Module
