﻿Imports System.Windows.Annotations
Imports System.Windows.Annotations.Storage
Imports System.IO

Public Class ManipulatingDocuments

    Dim annotationStream As FileStream

    Private Sub ManipulatingDocuments_Initialized(ByVal sender As Object,
                                              ByVal e As System.EventArgs) _
                                              Handles Me.Initialized

        'Gets the instance of the AnnotationService pointing to the FlowDocument
        Dim annotationServ As AnnotationService = AnnotationService.GetService(FlowReader1)

        'Declares a store for annotations
        Dim annotationArchive As AnnotationStore

        'If no annotation service already exists for
        'the current flow document...
        If annotationServ Is Nothing Then
            '...creates a new service
            ' and a new store to an Xml file
            annotationStream = New FileStream("annotations.xml",
                                              FileMode.OpenOrCreate)
            annotationServ = New AnnotationService(FlowReader1)

            'Gets the instance of the stream
            annotationArchive = New XmlStreamStore(annotationStream)

            'Enables the document
            annotationServ.Enable(annotationArchive)
        End If
    End Sub

    Private Sub ManipulatingDocuments_Closed(ByVal sender As Object,
                                             ByVal e As System.EventArgs) _
                                             Handles Me.Closed
        Dim annotationServ As AnnotationService = _
            AnnotationService.GetService(FlowReader1)

        'If an instance of the annotation
        'service is available
        If annotationServ IsNot Nothing And _
            annotationServ.IsEnabled Then

            'shuts down the service
            'and releases resources
            annotationServ.Store.Flush()
            annotationServ.Disable()
            annotationStream.Close()
        End If
    End Sub

End Class
