﻿Imports IntroducingDataBinding

Public Class MasterDetails

    Private northwindContext As NorthwindEntities

    Private CustomersViewSource As CollectionViewSource
    Private CustomersOrdersViewSource As CollectionViewSource


    Private WithEvents CustomerView As BindingListCollectionView
    Private CustomersOrdersView As BindingListCollectionView

    Private Sub CustomerView_CurrentChanged(ByVal sender As Object,
                                            ByVal e As System.EventArgs) _
                                            Handles CustomerView.CurrentChanged
        Me.CustomersOrdersView = CType(Me.CustomersOrdersViewSource.View, 
                                 BindingListCollectionView)
    End Sub

    Private Sub Window_Loaded(ByVal sender As System.Object,
                              ByVal e As System.Windows.RoutedEventArgs) _
                              Handles MyBase.Loaded

        Me.CustomersViewSource = CType(Me.FindResource("CustomersViewSource"), 
                                System.Windows.Data.CollectionViewSource)
        Me.CustomersOrdersViewSource = CType(Me.FindResource("CustomersOrdersViewSource"), CollectionViewSource)

        'Load data by setting the CollectionViewSource.Source property:
        CustomersViewSource.Source = Me.northwindContext.Customers.Include("Orders").
                                    Execute(System.Data.Objects.MergeOption.AppendOnly)

        Me.CustomerView = CType(Me.CustomersViewSource.View, BindingListCollectionView)
        Me.CustomersOrdersView = CType(Me.CustomersOrdersViewSource.View, BindingListCollectionView)
    End Sub

    Private Function GetCustomersQuery(ByVal NorthwindEntities As IntroducingDataBinding.NorthwindEntities) As System.Data.Objects.ObjectQuery(Of IntroducingDataBinding.Customer)

        Dim CustomersQuery As System.Data.Objects.ObjectQuery(Of IntroducingDataBinding.Customer) = NorthwindEntities.Customers
        'Update the query to include Orders data in Customers. You can modify this code as needed.
        CustomersQuery = CustomersQuery.Include("Orders")
        'Returns an ObjectQuery.
        Return CustomersQuery
    End Function


    Private Sub SaveButton_Click(ByVal sender As System.Object,
                                 ByVal e As System.Windows.
                                 RoutedEventArgs)
        'Handle your logic here, such as exceptions
        'and optmistic concurrency
        Try
            Me.northwindContext.SaveChanges()
        Catch ex As Exception

        End Try
    End Sub

    Private Sub AddButton_Click(ByVal sender As System.Object,
                                ByVal e As System.Windows.RoutedEventArgs)
        'A new order
        Dim newOrder As Order

        'Adds a new order to the view and assigns the instance
        'to the newly declared order
        newOrder = CType(Me.CustomersOrdersView.AddNew(), Order)

        'If I need to assign properties to newOrder before
        'it is sent to the collection, then this is the place

        'Sends the new order to the view
        Me.CustomersOrdersView.CommitNew()
    End Sub

    Private Sub DeleteButton_Click(ByVal sender As System.Object,
                                   ByVal e As System.Windows.RoutedEventArgs)
        If Me.CustomersOrdersView.CurrentPosition > -1 Then

            Dim result = MessageBox.Show("Are you sure?",
                                         "", MessageBoxButton.YesNo)
            If result = MessageBoxResult.Yes Then
                Me.CustomersOrdersView.RemoveAt(Me.
                                                CustomersOrdersView.CurrentPosition)
            Else
                Exit Sub
            End If
        End If
    End Sub

    Private Sub NextButton_Click(ByVal sender As System.Object,
                                 ByVal e As System.Windows.RoutedEventArgs)
        If Me.CustomersOrdersViewSource.View.CurrentPosition < _
              CType(Me.CustomersOrdersViewSource.View, CollectionView).Count - 1 Then
            Me.CustomersOrdersViewSource.View.MoveCurrentToNext()
        End If
    End Sub

    Private Sub BackButton_Click(ByVal sender As System.Object,
                                 ByVal e As System.Windows.RoutedEventArgs)
        If Me.CustomersOrdersViewSource.View.CurrentPosition > 0 Then
            Me.CustomersOrdersViewSource.View.MoveCurrentToPrevious()
        End If
    End Sub

    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        Me.northwindContext = New NorthwindEntities

    End Sub
End Class
