﻿
Option Compare Binary
Option Infer On
Option Strict On
Option Explicit On

Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.ComponentModel.DataAnnotations
Imports System.Linq
Imports System.ServiceModel.DomainServices.Hosting
Imports System.ServiceModel.DomainServices.Server


'The MetadataTypeAttribute identifies OrderMetadata as the class
' that carries additional metadata for the Order class.
<MetadataTypeAttribute(GetType(Order.OrderMetadata))>  _
Partial Public Class Order
    
    'This class allows you to attach custom attributes to properties
    ' of the Order class.
    '
    'For example, the following marks the Xyz property as a
    ' required field and specifies the format for valid values:
    '    <Required>
    '    <RegularExpression("[A-Z][A-Za-z0-9]*")>
    '    <StringLength(32)>
    '    Public Xyz As String
    Friend NotInheritable Class OrderMetadata
        
        'Metadata classes are not meant to be instantiated.
        Private Sub New()
            MyBase.New
        End Sub
        
        Public Property CustomerID As String
        
        Public Property EmployeeID As Nullable(Of Integer)
        
        Public Property Freight As Nullable(Of Decimal)
        
        Public Property OrderDate As Nullable(Of DateTime)
        
        Public Property OrderID As Integer
        
        Public Property RequiredDate As Nullable(Of DateTime)
        
        Public Property ShipAddress As String
        
        Public Property ShipCity As String
        
        Public Property ShipCountry As String
        
        Public Property ShipName As String
        
        Public Property ShippedDate As Nullable(Of DateTime)
        
        Public Property ShipPostalCode As String
        
        Public Property ShipRegion As String
        
        Public Property ShipVia As Nullable(Of Integer)
    End Class
End Class

