﻿
Option Compare Binary
Option Infer On
Option Strict On
Option Explicit On

Imports NorthwindBusinessApplication
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.ComponentModel.DataAnnotations
Imports System.Data
Imports System.Linq
Imports System.ServiceModel.DomainServices.EntityFramework
Imports System.ServiceModel.DomainServices.Hosting
Imports System.ServiceModel.DomainServices.Server


'Implements application logic using the NorthwindEntities context.
' TODO: Add your application logic to these methods or in additional methods.
' TODO: Wire up authentication (Windows/ASP.NET Forms) and uncomment the following to disable anonymous access
' Also consider adding roles to restrict access as appropriate.
'<RequiresAuthentication> _
<EnableClientAccess()>  _
Public Class OrdersDomainService
    Inherits LinqToEntitiesDomainService(Of NorthwindEntities)
    
    'TODO:
    ' Consider constraining the results of your query method.  If you need additional input you can
    ' add parameters to this method or create additional query methods with alternate signatures.
    ' Alternatively, to mark this as the default parameterless query for this entity type, apply the
    ' QueryAttribute custom attribute and set its IsDefault property to true.
    Public Function GetOrders() As IQueryable(Of Order)
        Return Me.ObjectContext.Orders.OrderBy(Function(ord) ord.CustomerID)
    End Function
    
    Public Sub InsertOrder(ByVal order As Order)
        If ((order.EntityState = EntityState.Detached)  _
                    = false) Then
            Me.ObjectContext.ObjectStateManager.ChangeObjectState(order, EntityState.Added)
        Else
            Me.ObjectContext.Orders.AddObject(order)
        End If
    End Sub
    
    Public Sub UpdateOrder(ByVal currentOrder As Order)
        Me.ObjectContext.Orders.AttachAsModified(currentOrder, Me.ChangeSet.GetOriginal(currentOrder))
    End Sub
    
    Public Sub DeleteOrder(ByVal order As Order)
        If (order.EntityState = EntityState.Detached) Then
            Me.ObjectContext.Orders.Attach(order)
        End If
        Me.ObjectContext.Orders.DeleteObject(order)
    End Sub

    Public Sub SaveChanges()
        Me.ObjectContext.SaveChanges()
    End Sub

End Class

