﻿Imports NorthwindClient.NorthwindServiceReference
Imports System.Data.Services.Client

Module Module1

    Private northwind As New  _
            NorthwindEntities(New Uri("http://localhost:1443/NorthwindService.svc"))

    Sub Main()

        Dim cust = northwind.Customers.Where(Function(c) c.CustomerID = "ALFKI").First

        Try
            Dim anOrder = AddNewOrder(cust)

            Console.WriteLine("Added new order: {0}", anOrder.OrderID)

            UpdateOrder(anOrder.OrderID)
            Console.WriteLine("Updated order {0}. ShipCity now is {1}, ShipName now is {2}",
                              anOrder.OrderID, anOrder.ShipCity, anOrder.ShipName)

            'Replace the order ID with a valid one
            DeleteOrder(anOrder.OrderID)
            Console.WriteLine("Order deleted")

            SaveAllChanges()

            'ViewDetails(10250)
            Console.ReadLine()
            northwind = Nothing

            Dim myOrders = From ord In northwind.Orders
                           Where ord.Customer.CustomerID = "ALFKI"
                           Select ord

        Catch ex As DataServiceQueryException
            Console.WriteLine("The server returned the following error:")
            Console.WriteLine(ex.Response.Error.Message)
            Console.ReadLine()
        Catch ex As Exception

        End Try
    End Sub

    Private Sub SaveAllChanges()
        northwind.SaveChanges(Services.Client.SaveChangesOptions.Batch)
    End Sub

    Private Sub UpdateOrder(ByVal OrderID As Integer)
        Dim ord = northwind.Orders.Where(Function(o) o.OrderID = OrderID).First

        ord.ShipName = "Second"
        ord.ShipCity = "Cremona"
        ord.ShipCountry = "Italy"
    End Sub

    '11079
    Private Sub DeleteOrder(ByVal OrderID As Integer)

        Dim ord = northwind.Orders.Where(Function(o) o.OrderID = OrderID).First
        northwind.DeleteObject(ord)
    End Sub


    Private Function AddNewOrder(ByVal relatedCustomer As Customer) As Order

        Dim newOrder As New Order
        With newOrder
            .Customer = relatedCustomer
            .OrderDate = Date.Today
            .ShipCountry = "Italy"
            .ShipCity = "Milan"
            .ShipName = "First"
        End With

        northwind.AddToOrders(newOrder)
        northwind.SetLink(newOrder, "Customer", relatedCustomer)
        northwind.SaveChanges()
        Return newOrder
    End Function

    Private Sub ViewDetails(ByVal OrderID As Integer)
        Console.WriteLine("Showing details for Order ID: " _
                          & OrderID.ToString)

        Dim details = northwind.Execute(Of Order_Detail) _
                      (New Uri("GetOrderDetails?OrderID=" & OrderID.ToString,
                       UriKind.Relative))

        For Each detail In details
            Console.WriteLine("ID: {0}, Unit price: {1}, Quantity: {2}", detail.OrderID,
                                                                         detail.UnitPrice,
                                                                         detail.Quantity)
        Next
        Console.ReadLine()
    End Sub

End Module
