﻿Imports NorthwindClient2.NorthwindServiceReference.
        NorthwindModel
Imports System.Data.Services.Client

Class MainWindow

    Private CustomersViewSource As CollectionViewSource
    Private CustomerOrdersViewSource As CollectionViewSource
    Private northwind As NorthwindEntities
    Private customersQuery As DataServiceQuery(Of Customer)

    Private Sub Window_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded

        CustomersViewSource = CType(Me.FindResource("CustomersViewSource"), System.Windows.Data.CollectionViewSource)
        'Load data by setting the CollectionViewSource.Source property:
        'CustomersViewSource.Source = [generic data source]

        Try
            Me.customersQuery = northwind.Customers.Expand("Orders")
            'Load data by setting the CollectionViewSource.Source property:
            CustomersViewSource.Source = Me.customersQuery.Execute
        Catch ex As DataServiceQueryException
            MessageBox.Show("The server returned the following error:" & _
                            ex.InnerException.Message)
        Catch ex As Exception

        End Try
    End Sub

    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        Me.northwind = New NorthwindEntities(New Uri("http://localhost:1443/NorthwindService.svc"))
    End Sub

    Private Sub SaveButton_Click(ByVal sender As System.Object,
                                 ByVal e As System.Windows.RoutedEventArgs) Handles SaveButton.Click
        Try
            Me.northwind.SaveChanges(SaveChangesOptions.Batch)
        Catch ex As Exception

        End Try
    End Sub

    Private Sub AddButton_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles AddButton.Click

        With CType(CustomerOrdersViewSource.View, BindingListCollectionView)
            .AddNew()
            .CommitNew()
        End With


    End Sub
End Class
