﻿'Attribute is not inherited
<AttributeUsage(AttributeTargets.Class Or AttributeTargets.Property, AllowMultiple:=True)>
Public Class DocumentPropertiesAttribute
    Inherits Attribute

    'Attributes can be inherited
    'therefore private fields are Protected
    Protected _author As String
    Protected _reviewer As String

    Public Overridable ReadOnly Property Author As String
        Get
            Return Me._author
        End Get
    End Property

    Public Overridable ReadOnly Property Reviewer As String
        Get
            Return Me._reviewer
        End Get
    End Property

    Public Overridable Property LastEdit As String

    Public Sub New(ByVal author As String, ByVal reviewer As String)
        Me._author = author
        Me._reviewer = reviewer
        Me._LastEdit = CStr(Date.Today)
    End Sub
End Class