﻿
Public Class Sheet1

    Private Sub Sheet1_Startup() Handles Me.Startup

    End Sub

    Private Sub Sheet1_Shutdown() Handles Me.Shutdown

    End Sub
    Private Function GetOrders(ByVal criteria As String) As String

        'Creates a collection of Order objects
        Dim result As New List(Of Order)

        'Declares a Range object, which represents
        'a set of Excel cells
        Dim cellRange As Excel.Range

        Dim oneOrder As Order

        'Gets the content of the specified cells range
        'resizing the array
        cellRange = CustomExcelWorkbook.Globals.Sheet1.Range("Orders").Resize(1, 1)

        'Loops until a null value is found
        Do Until IsNothing(cellRange.Value)
            'creates a new Order...
            oneOrder = New Order With {.OrderID = cellRange.Value.ToString, _
                       .ShipCountry = cellRange.Offset(0, 1).Value.ToString, _
                       .ShippedDate = CDate(cellRange.Offset(0, 2).Value)}

            '...adding it to the collection..
            result.Add(oneOrder)
            '...then moves to the next row
            cellRange = cellRange.Offset(1, 0)
        Loop

        'Queries for orders matching the specified criteria
        Dim query = From ord As Order In result
                    Where ord.ShipCountry.ToString.StartsWith(criteria)
                    Select ord

        Dim ordersList As New Text.StringBuilder

        For Each item In query
            ordersList.Append(item.OrderID.ToString)
            ordersList.AppendLine()
        Next

        Return ordersList.ToString

    End Function

    Private Sub FilterButton_Click(ByVal sender As System.Object,
                               ByVal e As System.EventArgs) Handles FilterButton.Click

        MessageBox.Show("The following orders match your search criteria: " & _
                        Environment.NewLine & GetOrders(Me.FilterTextBox.Text))
    End Sub

End Class
