﻿Imports System.Diagnostics.Contracts

Module Module1

    Sub Main()
        Dim r As New Rectangle(0, 80)
        Console.WriteLine(r.CalculatePerimeter)
        Console.ReadLine()

        Console.ReadLine()
        r = Nothing
    End Sub


End Module

Class Rectangle

    Property Width As Double
    Property Height As Double

    '<ContractInvariantMethod()>
    'Protected Sub ObjectInvariant()
    '    Contract.Invariant(Me.Width > 0)
    '    Contract.Invariant(Me.Height > 0)
    'End Sub

    Function CalculatePerimeter() As Double

        Contract.Requires(Me.Height > 0)

        Contract.Requires(Of ArgumentOutOfRangeException) _
                 (Me.Width > 0)

        Contract.Ensures(Contract.Result(Of Double)() > 0)

        Dim result = (Width * 2) + (Height * 2)
        Return result
    End Function

    Sub New(ByVal width As Double, ByVal height As Double)
        Me.Width = width
        Me.Height = height

        AddHandler Contract.ContractFailed,
                   AddressOf Contract_ContractFailed
    End Sub

    Private Sub Contract_ContractFailed(ByVal sender As Object,
                                        ByVal e As ContractFailedEventArgs)
        Console.WriteLine("The following contract failed: {0}, {1}",
                          e.Condition, e.FailureKind.ToString)
    End Sub
End Class